//+------------------------------------------------------------------+
//|                                                        SmCCI.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Gold
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 Blue
#property indicator_color7 Red

//---- input parameters


extern int t3_period=89;
extern double b=0.7;
extern int Delta=89;
extern int Delta2=144;
extern int Delta3=233;
extern int RP_Shift=0;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexShift(0,RP_Shift);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexShift(1,RP_Shift);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexShift(2,RP_Shift);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexShift(3,RP_Shift);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexShift(4,RP_Shift);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);  
   SetIndexShift(5,RP_Shift);    
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexShift(6,RP_Shift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double e1, e2, e3, e4, e5, e6, c1, c2, c3, c4, n, w1, w2, b2, b3;
   double dpo, t3, tup, tdown, tup2, tdown2, tup3, tdown3;

   b2=b*b;
   b3=b2*b;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+b+b3);
   c4=(1+3*b+b3+3*b2);
   n=t3_period;

   if (n<1) n=1;
   n = 1 + 0.5*(n-1);
   w1 = 2 / (n + 1);
   w2 = 1 - w1;
  
   
   
   for(int i=Bars; i>=0; i--)
   
   {
      
      dpo=Close[i];

      e1 = w1*dpo + w2*e1;
      e2 = w1*e1 + w2*e2;
      e3 = w1*e2 + w2*e3;
      e4 = w1*e3 + w2*e4;
      e5 = w1*e4 + w2*e5;
      e6 = w1*e5 + w2*e6;

      t3 = c1*e6 + c2*e5 + c3*e4 + c4*e3;
      ExtMapBuffer1[i]=t3;
      
            
      tdown=ExtMapBuffer1[i]+(Delta*Point);
      ExtMapBuffer2[i]=tdown;
      
      tup=ExtMapBuffer1[i]-(Delta*Point);
      ExtMapBuffer3[i]=tup;
      
      tdown2=ExtMapBuffer1[i]+(Delta2*Point);
      ExtMapBuffer4[i]=tdown2;
      
      tup2=ExtMapBuffer1[i]-(Delta2*Point);
      ExtMapBuffer5[i]=tup2;
      
      tdown3=ExtMapBuffer1[i]+(Delta3*Point);
      ExtMapBuffer6[i]=tdown3;
      
      tup3=ExtMapBuffer1[i]-(Delta3*Point);
      ExtMapBuffer7[i]=tup3;
   }
   
   return(0);
  }
//+------------------------------------------------------------------+